package outwatchapp.components

import scala.concurrent.duration._

import colibri.ext.monix._
import com.softwaremill.tagging._
import monix.bio._
import monix.reactive.Observable
import outwatch.HtmlVNode
import outwatch.dsl._

sealed trait CounterDemo
object CounterDemo {
  val counter2 = Observable.interval(1.second)
  def apply(): Task[HtmlVNode @@ CounterDemo] =
    Task.deferAction(implicit s =>
      Task(
        div(p(cls := "text-white", "count: ", counter2))
          .taggedWith[CounterDemo]
      )
    )
}
