package outwatchapp.components
import scala.scalajs.js.annotation.JSImport

import monix.bio.Task
import outwatchapp.implicits._
import typings.sweetalert2.mod.SweetAlertIcon
import typings.sweetalert2.mod.SweetAlertOptions
import typings.sweetalert2.mod.SweetAlertPosition

import scalajs.js

object SweetAlertDemo {
  @JSImport(
    "@sweetalert2/themes/borderless/borderless.min.css",
    JSImport.Namespace
  )
  @js.native
  object SweetAlertBorderlessTheme extends js.Object
  @JSImport("@sweetalert2/themes/dark/dark.min.css", JSImport.Namespace)
  @js.native
  object SweetAlertDarkTheme extends js.Object
  @JSImport("sweetalert2/dist/sweetalert2.js", JSImport.Namespace)
  @js.native
  object SweetAlertJs extends js.Object

  SweetAlertDarkTheme
  val Swal = SweetAlertJs.asInstanceOf[typings.sweetalert2.mod.default.type]

  val loginPrompt = {
    import scalatags.JsDom.all._

    val nameInput = input(
      tpe := "text",
      `id` := "loginName",
      cls := "swal-input",
      placeholder := "Username"
    ).render
    val passInput = input(
      tpe := "password",
      `id` := "loginPass",
      cls := "swal-input",
      placeholder := "Password"
    ).render
    val html = div(nameInput, passInput).render.asST

    def nameAndPass(a: js.Any) = (nameInput.value, passInput.value)

    Swal.fireL(
      SweetAlertOptions()
        .setTitle("Login Form")
        .setHtml(html)
        .setFocusConfirm(false)
        .setConfirmButtonText("Sign In")
        .setPreConfirm(nameAndPass _)
    )

  }

  val successPrompt =
    Swal.fireL(
      SweetAlertOptions()
        .setPosition(SweetAlertPosition.`top-end`)
        .setIcon(SweetAlertIcon.success)
        .setTitle("Login Success")
        .setShowConfirmButton(false)
        .setTimer(1500)
    ) >> Task.unit

  val failurePrompt =
    Swal.fireL(
      SweetAlertOptions()
        .setPosition(SweetAlertPosition.`top-end`)
        .setIcon(SweetAlertIcon.error)
        .setTitle("Login Failure")
        .setShowConfirmButton(false)
        .setTimer(1500)
    ) >> Task.unit

  val dumbNotif =
    Swal
      .fireL(
        SweetAlertOptions()
          .setTitle("Hello there")
          .setText("Welcome to outwatch app")
          // .setInput(SweetAlertInput.text)
          // .setShowCancelButton(true)
          .setIcon(SweetAlertIcon.info)
        // .setToast(true)
        // .setPreConfirm { res: String =>
        //   val username = Swal.getPopup().asOption
        //   username match {
        //     case Some(value) =>
        //       println(s"Got value: $value")
        //       1
        //     case None =>
        //       println("Got none")
        //       2
        //   }
        //   res
        // }
      ) >> Task.unit
  // .map(_.value.toOption)

}
