package outwatchapp.util

import monix.reactive.Observable
import monix.reactive.Observer

package object reactive {
  type MonixProSubject[-I, +O] = Observable[O] with Observer[I]
  type MonixSubject[A] = MonixProSubject[A, A]
  type WebWorker[A] = MonixSubject[A]
  type WebSocket[A] = MonixSubject[A]
  type DedicatedWorker[A] = MonixSubject[A]
}
