package outwatchapp.util.reactive

import monix.reactive.Observable

package object store {
  type Middleware[A, M] = Observable[(A, M)] => Observable[(A, M)]
  type Store[A, M] = MonixProSubject[A, (A, M)]

  /** A Function that applies an Action onto the Stores current state.
    * @param reducer The reducing function
    * @tparam A The Action Type
    * @tparam M The Model Type
    */
  type Reducer[A, M] = (M, A) => (M, Observable[A])
}
