var webpack = require('webpack');
var merge = require('webpack-merge');
var common = require('./webpack.config.common.js');
var Path = require('path');
const rootDir = Path.resolve(__dirname, '../../../..');

var local = {
    devServer: {
        contentBase: [
            Path.resolve(__dirname, 'dev'), // fastOptJS output
            Path.resolve(rootDir, 'assets') // project root containing index.html
        ],
        watchContentBase: true,
        hot: false,
        hotOnly: false, // only reload when build is successful
        inline: true, // live reloading
        watchOptions: {
            poll: 1000,
            ignored: ["node_modules"]
        }
    },
};

module.exports = merge(common, local);
